import {
  select,
  hierarchy,
  pack
} from 'd3';

const svg = select('svg');
const g = svg.append('g');
const width = +svg.attr('width');
const height = +svg.attr('height');

const render = () => {
  var data = {
    "name": "A1",
    "children": [
      {
        "name": "B1",
        "children": [
          {
            "name": "C1",
            "value": 100
          },
          {
            "name": "C2",
            "value": 300
          },
          {
            "name": "C3",
            "value": 200
          }
        ]
      },
      {
        "name": "B2",
        "value": 200
      }
    ]
  };
  
  var root = hierarchy(data);
  root.sum((d) => d.value);
  
  var packLayout = pack()
  	.size([300,300])
    .padding(10);
  
  packLayout(root);
  
  var nodes = svg.append('g')
    .selectAll('g')
    .data(root.descendants())
    .enter()
    .append('g')
    .attr('transform', (d) => `translate(${d.x},${d.y})`);
  
  nodes
    .append('circle')
    .attr('r', (d) => d.r);
  
  nodes
    .append('text')
    .attr('dy', 4)
    .text((d) => (d.children === undefined) ? d.data.name : '');
  
  // svg.append('g')
  //   .selectAll('circle')
  //   .data(root.descendants())
  //   .enter()
  //   .append('circle')
  //     .attr('cx', (d) => d.x)
  //     .attr('cy', (d) => d.y)
  //     .attr('r', (d) => d.r);
  
};

render();


















